	program reduction
	
C This program can be used in conjunction with the following
C UNIX commands to extract and reduce data from the pexp & rexp
C files.
C The current directory of Vaal should be:
*
C   /home/louge/granular/3dflat/results
*

C Michel Louge 6/3/93

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C The UNIX script below permits extraction of relevant
C data from the pexp and rexp files generated by the
C cou3fb.f simulations (version MYL 4/28/1992).
C Executable lines are preceded by a C sign; remove
C these signs before use. Comments are preceded by a C
C sign.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C Create a file called "pilot" containing all necessary commands.
C The file will be edited by the SED stream editor called
C by the "process" file to handle each new set of simulations:

C cd pexpfiles 
C ls pname* | wc -w  > ../datname
C ls -1 - pname* | sed "s/pname//" >> ../datname
C cd ../rexpfiles 
C ls rname* | wc -w  >> ../datname 
C grep "radius1T" rname* | wc -l >> ../datname 
C grep "radius2T" rname* | wc -l >> ../datname 
C ls -1 - rname* | sed "s/rname//" >> ../datname
C cd ../pexpfiles 
C grep u/sq pname* | cut -f2 -d")" >> ../datname 
C grep p/sq pname* | cut -f2 -d")" >> ../datname 
C grep wd/2 pname* | cut -f2 -d")" >> ../datname 
C grep ar/r pname* | cut -f2 -d"T" >> ../datname 
C grep s./r pname* | cut -f2 -d"T" >> ../datname 
C grep "tr. t"  pname* | cut -f2 -d"T" >> ../datname 
C grep ro.  pname* | cut -f2 -d"T" >> ../datname 
C grep "T^3/"  pname* | cut -f3 -d/ | sed "s/2//" >> ../datname
C grep "R D" pname* | cut -f2 -ds >> ../datname 
C grep "O D" pname* | cut -f2 -ds >> ../datname 
C grep "wall velocity" pname1 | cut -f2 -d"y" >> ../datname 
C grep "restitution wall" pname1 | cut -f3 -d"l" >> ../datname 
C cd ../rexpfiles 
C grep "radius1T" rname* | cut -f2 -d"T" >> ../datname 
C grep "radius1T" rname* | cut -f3 -d"T" >> ../datname 
C grep "radius1T" rname* | cut -f4 -d"T" >> ../datname 
C grep "radius2T" rname* | cut -f2 -d"T" >> ../datname 
C grep "radius2T" rname* | cut -f3 -d"T" >> ../datname 
C grep "radius2T" rname* | cut -f4 -d"T" >> ../datname 
C ls rname* > ../dname 
C cd ../pexpfiles 
C ls pname* >> ../dname 
C grep restitution pname1 >> ../dname 
C grep friction pname1 >> ../dname 
C grep height pname1 >> ../dname 
C cd .. 
C reduction < datname >> dname
C rm datname

C create a file called "extract" with the vi editor;
C to make it executable use the chmod command:

C chmod 755 extract

C make a file called "process" to direct the extraction.
C In the following example, the pexD and rexD files will
C be processed.
C Because two different radii are needed, use the SED stream
C editor to update the "extract" file before processing the
C data. For example, with rexD files:

C sed "s/name/exD/g" pilot | sed "s/radius1/0.0938/g" \
C | sed "s/radius2/0.2604/g" > extract ; extract

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	integer*2 npexp,nrexp,nline1,nline2,nn
     	parameter (nn = 40)
	integer*2 indexp(nn),indexr(nn),
     &            minindex,maxindex
	real*4	u(nn),slip(nn),w(nn),shear(nn),pres(nn),
     &		TTr(nn),TR(nn),flux(nn),DTr(nn),DR(nn),
     &		eps(nn,2),
     &	     	u1(nn,2),u2(nn,2),u3(nn,2),
     &		w1(nn,2),w2(nn,2),w3(nn,2),
     &	     	uu1(nn,2),uu2(nn,2),uu3(nn,2),
     &		ww1(nn,2),ww2(nn,2),ww3(nn,2),
     &		R,uwall,rho,ew,refvel,dummy,tratio,pres1

		do i=1,nn
	u(i)     = 0.0
	slip(i)  = 0.0
	w(i)     = 0.0
	shear(i) = 0.0
	pres (i) = 0.0
	TTr(i)   = 0.0
	TR (i)   = 0.0
	flux(i)  = 0.0
	DTr(i)   = 0.0
	DR(i)    = 0.0
			do j=1,2
	eps(i,j) = 0.0
	u1(i,j)  = 0.0
	uu1(i,j)   = 0.0
	u2(i,j)   = 0.0
	uu2(i,j)   = 0.0
	u3(i,j)   = 0.0
	uu3(i,j)   = 0.0
	w1(i,j)   = 0.0
	ww1(i,j)   = 0.0
	w2(i,j)   = 0.0
	ww2(i,j)   = 0.0
	w3(i,j)   = 0.0
	ww3(i,j)   = 0.0
			end do
		end do

CC Data acquisition:

	maxindex = 1
	minindex = nn
	read (*,*) npexp
	do i=1,npexp
	read (*,*) indexp(i)
	if (indexp(i).gt.maxindex) maxindex=indexp(i)
	if (indexp(i).lt.minindex) minindex=indexp(i)
	end do
	
	read (*,*) nrexp
	read (*,*) nline1
	read (*,*) nline2
	do i=1,nrexp
	read (*,*) indexr(i)
	if (indexr(i).gt.maxindex) maxindex=indexr(i)
	if (indexr(i).lt.minindex) minindex=indexr(i)
	end do

	if (nline1.ne.4*nrexp.or.nline2.ne.4*nrexp) then
	write (*,'(a)') 'no of rexp lines is incorrect'
	stop
	end if
	
	do i = 1,npexp
	read (*,*) u(indexp(i))
	end do
	
	do i = 1,npexp
	read (*,*) slip(indexp(i))
	end do
	
	do i = 1,npexp	
	read (*,*) w(indexp(i))	
	end do

	do i = 1,npexp	
	read (*,*) shear(indexp(i))	
	end do

	do i = 1,npexp	
	read (*,*) pres(indexp(i))	
	end do

	do i = 1,npexp	
	read (*,*) TTr(indexp(i))	
	end do

	do i = 1,npexp	
	read (*,*) TR(indexp(i))	
	end do

	do i = 1,npexp	
	read (*,*) flux(indexp(i))	
	end do

	do i = 1,npexp	
	read (*,*) DTr(indexp(i))	
	end do

	do i = 1,npexp	
	read (*,*) DR(indexp(i))	
	end do
	
	read (*,*) uwall
	read (*,*) ew

		do j = 1,2
		
	do i = 1,nrexp	
	read (*,*) eps(indexr(i),j)
	read (*,*) w1(indexr(i),j)	
	read (*,*) uu1(indexr(i),j)	
	read (*,*) ww1(indexr(i),j)	
	end do
		
	do i = 1,nrexp	
	read (*,*) u1(indexr(i),j)
	read (*,*) w2(indexr(i),j)	
	read (*,*) uu2(indexr(i),j)	
	read (*,*) ww2(indexr(i),j)	
	end do

	do i = 1,nrexp	
	read (*,*) u2(indexr(i),j)
	read (*,*) w3(indexr(i),j)	
	read (*,*) uu3(indexr(i),j)	
	read (*,*) ww3(indexr(i),j)	
	end do
	
		end do

CC data reduction:

	rho = 1.0
	
C	write (*,'(/,a,/)')
C    &'g/sq(3T),u(1.5d)/u(d/2),Ttr(1.5d)/Ttr(d/2),Tr(1.5d)/Tr(d/2)'
	write (*,'(/)')
	
	do i = minindex,maxindex
	
        R = 0.0
        tratio = 0.0
	
		if (u(i).eq.0.0) go to 1

	slip(i)  = slip(i)/sqrt(3.*TTr(i))
     	
1	write (*,100) slip(i),(uwall+u1(i,2))/(uwall+u1(i,1)),
     &	(uu1(i,2)+uu2(i,2)+uu3(i,2))/(uu1(i,1)+uu2(i,1)+uu3(i,1)),
     &	(ww1(i,2)+ww2(i,2)+ww3(i,2))/(ww1(i,1)+ww2(i,1)+ww3(i,1))
     
100	format (3(e12.5,1HT),e12.5)
	
	end do
	
	stop
	end
	
